/*
 *  Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <string>
#include <utility>

#include <mcrouter/lib/RouteHandleTraverser.h>

#include "mcrouter/lib/carbon/example/gen/HelloGoodbyeMessages.h"

namespace hellogoodbye {

template <class Route>
class HelloGoodbyeRouteHandle;

class HelloGoodbyeRouteHandleIf {
 public:
  template <class Route>
  using Impl = HelloGoodbyeRouteHandle<Route>;

  /**
   * Returns a string identifying this route handle instance
   */
  virtual std::string routeName() const = 0;

  virtual ~HelloGoodbyeRouteHandleIf() = default;

  virtual GoodbyeReply route(const GoodbyeRequest&) = 0;
  virtual HelloReply route(const HelloRequest&) = 0;

virtual bool traverse(
    const GoodbyeRequest&,
    const facebook::memcache::RouteHandleTraverser<HelloGoodbyeRouteHandleIf>&) const = 0;
virtual bool traverse(
    const HelloRequest&,
    const facebook::memcache::RouteHandleTraverser<HelloGoodbyeRouteHandleIf>&) const = 0;
};

template <class Route>
class HelloGoodbyeRouteHandle : public HelloGoodbyeRouteHandleIf {
 public:
  template <class... Args>
  explicit HelloGoodbyeRouteHandle(Args&&... args)
      : route_(std::forward<Args>(args)...) {}
  std::string routeName() const override final {
    return route_.routeName();
  }

  GoodbyeReply route(const GoodbyeRequest& request) override final {
    return route_.route(request);
  }
  HelloReply route(const HelloRequest& request) override final {
    return route_.route(request);
  }

bool traverse(
    const GoodbyeRequest& request,
    const facebook::memcache::RouteHandleTraverser<HelloGoodbyeRouteHandleIf>& traverser)
    const override final {
  return route_.traverse(request, traverser);
}
bool traverse(
    const HelloRequest& request,
    const facebook::memcache::RouteHandleTraverser<HelloGoodbyeRouteHandleIf>& traverser)
    const override final {
  return route_.traverse(request, traverser);
}

 private:
  Route route_;
};
} // namespace hellogoodbye
