/*
 *  Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
include "mcrouter/lib/carbon/carbon.thrift"
include "mcrouter/lib/carbon/carbon_result.thrift"
include "mcrouter/lib/network/gen/Common.thrift"

cpp_include "<mcrouter/lib/carbon/CarbonProtocolReader.h>"
cpp_include "<mcrouter/lib/carbon/test/Timestamp.h>"

namespace cpp2 carbon.test.thrift
typedef i64 (
  cpp.adapter = "carbon::test::TimestampAdapter"
) CustomAdapterTypeI64

typedef binary (
  cpp.adapter = "::carbon::test::DummyPairAdapter<::carbon::test::Timestamp,uint32_t>",
  cpp.type = "::folly::IOBuf"
) CustomAdapterTypeBinary

enum MyEnum {
  A = 0,
  B = 1,
  C = 2
} (cpp.enum_type="int32_t")

union TestUnionThrift {
  1: i64 (cpp.type = "uint64_t") a
  2: i32 (cpp.type = "uint32_t") b
  3: i16 (cpp.type = "uint16_t") c
}(cpp.methods = "
 public:
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

  template <class V>
  void foreachMember(V&& v);

  template <class V>
  void foreachMember(V&& v) const;
")
struct TinyStruct {
  1: i64 foo
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

")
struct MyBaseStruct {
  1: i64 baseInt64Member
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

")
struct MySimpleStruct {
  -1: MyBaseStruct myBaseStruct (cpp.mixin)
  1: i32 int32Member
  2: string stringMember
  3: MyEnum enumMember
  4: list<string> vectorMember
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

")
struct ThriftTestRequest {
  -2: TinyStruct tinyStruct (cpp.mixin)
  -1: MySimpleStruct base (cpp.mixin)
  1: carbon.IOBufKey key
  2: bool testBool
  3: byte testInt8
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
struct ThriftTestReply {
  1: carbon_result.Result result
  2: string message
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
struct DummyThriftRequest {
  1: carbon.IOBufKey key
  2: bool testBool
  3: byte testInt8
  4: i16 testInt16
  5: i32 testInt32
  6: i64 testInt64
  7: byte (cpp.type = "uint8_t") testUInt8
  8: i16 (cpp.type = "uint16_t") testUInt16
  9: i32 (cpp.type = "uint32_t") testUInt32
  10: i64 (cpp.type = "uint64_t") testUInt64
  11: float testFloat
  12: double testDouble
  13: string testShortString
  14: string testLongString
  15: binary (cpp.type = "folly::IOBuf") testIobuf
  16: list<string> testList
  17: optional bool testOptionalKeywordBool
  18: optional string testOptionalKeywordString
  19: optional binary (cpp.type = "folly::IOBuf") testOptionalKeywordIobuf
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
struct DummyThriftReply {
  1: carbon_result.Result result
  2: string message
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
struct CustomRequest {
  1: carbon.IOBufKey key
  2: byte testInt8
  3: i64 (cpp.type = "Timestamp", cpp.indirection) timestamp
  4: optional CustomAdapterTypeI64 customAdapterTypeI64
  5: CustomAdapterTypeBinary customAdapterTypeBinary
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
struct CustomReply {
  1: carbon_result.Result result
  2: i32 valInt32
}(cpp.methods = "
  template <class V>
  void visitFields(V&& v);
  template <class V>
  void visitFields(V&& v) const;

  template <class Writer>
  void serialize(Writer&& writer) const;

  void deserialize(carbon::CarbonProtocolReader& reader);

",
cpp.virtual
)
