/*
 *  Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <memory>
#include <string>
#include <unordered_map>
#include <vector>

#include <mcrouter/lib/CacheClientStats.h>
#include <mcrouter/lib/carbon/connection/ExternalCarbonConnectionImpl.h>
#include <mcrouter/lib/carbon/connection/InternalCarbonConnectionImpl.h>
#include <mcrouter/lib/carbon/connection/PooledCarbonConnectionImpl.h>

#include "mcrouter/lib/carbon/test/gen/CarbonThriftTestMessages.h"
#include "mcrouter/lib/carbon/test/gen/CarbonThriftTestRouterInfo.h"

namespace carbon {
namespace test {

class CarbonThriftTestConnection {
 public:
  using RouterInfo = CarbonThriftTestRouterInfo;

  virtual ~CarbonThriftTestConnection() = default;

  virtual void sendRequestOne(
      const CustomRequest&,
      carbon::RequestCb<CustomRequest>) = 0;
  virtual void sendRequestOne(
      const DummyThriftRequest&,
      carbon::RequestCb<DummyThriftRequest>) = 0;
  virtual void sendRequestOne(
      const ThriftTestRequest&,
      carbon::RequestCb<ThriftTestRequest>) = 0;

  virtual void sendRequestMulti(
      std::vector<std::reference_wrapper<const CustomRequest>>&&,
      carbon::RequestCb<CustomRequest>) = 0;
  virtual void sendRequestMulti(
      std::vector<std::reference_wrapper<const DummyThriftRequest>>&&,
      carbon::RequestCb<DummyThriftRequest>) = 0;
  virtual void sendRequestMulti(
      std::vector<std::reference_wrapper<const ThriftTestRequest>>&&,
      carbon::RequestCb<ThriftTestRequest>) = 0;

  virtual facebook::memcache::CacheClientCounters getStatCounters() const noexcept = 0;
  virtual std::unordered_map<std::string, std::string> getConfigOptions() = 0;
  virtual bool healthCheck() = 0;
  virtual std::unique_ptr<CarbonThriftTestConnection> recreate() = 0;
};

template <class Impl>
class CarbonThriftTestConnectionImpl : public CarbonThriftTestConnection {
 public:
  template <class... Args>
  explicit CarbonThriftTestConnectionImpl(Args&&... args)
      : impl_(std::forward<Args>(args)...) {}

  ~CarbonThriftTestConnectionImpl() = default;

  facebook::memcache::CacheClientCounters getStatCounters() const noexcept {
    return impl_.getStatCounters();
  }

  std::unordered_map<std::string, std::string> getConfigOptions() {
    return impl_.getConfigOptions();
  }

  bool healthCheck() {
    return impl_.healthCheck();
  }

  std::unique_ptr<CarbonThriftTestConnection> recreate() {
    return impl_.template recreate<CarbonThriftTestConnectionImpl<Impl>>();
  }

  void sendRequestOne(
      const CustomRequest& req,
      carbon::RequestCb<CustomRequest> cb) {
    return impl_.sendRequestOne(req, std::move(cb));
  }
  void sendRequestOne(
      const DummyThriftRequest& req,
      carbon::RequestCb<DummyThriftRequest> cb) {
    return impl_.sendRequestOne(req, std::move(cb));
  }
  void sendRequestOne(
      const ThriftTestRequest& req,
      carbon::RequestCb<ThriftTestRequest> cb) {
    return impl_.sendRequestOne(req, std::move(cb));
  }

  void sendRequestMulti(
      std::vector<std::reference_wrapper<const CustomRequest>>&& reqs,
      carbon::RequestCb<CustomRequest> cb) {
    return impl_.sendRequestMulti(std::move(reqs), std::move(cb));
  }
  void sendRequestMulti(
      std::vector<std::reference_wrapper<const DummyThriftRequest>>&& reqs,
      carbon::RequestCb<DummyThriftRequest> cb) {
    return impl_.sendRequestMulti(std::move(reqs), std::move(cb));
  }
  void sendRequestMulti(
      std::vector<std::reference_wrapper<const ThriftTestRequest>>&& reqs,
      carbon::RequestCb<ThriftTestRequest> cb) {
    return impl_.sendRequestMulti(std::move(reqs), std::move(cb));
  }

 private:
  Impl impl_;
};

using CarbonThriftTestPooledConnection =
    CarbonThriftTestConnectionImpl<carbon::PooledCarbonConnectionImpl<CarbonThriftTestConnection>>;
using CarbonThriftTestInternalConnection =
    CarbonThriftTestConnectionImpl<carbon::InternalCarbonConnectionImpl<CarbonThriftTestConnection>>;
using CarbonThriftTestExternalConnection =
    CarbonThriftTestConnectionImpl<carbon::ExternalCarbonConnectionImpl<CarbonThriftTestRouterInfo>>;
} // namespace test
} // namespace carbon
