/*
 *  Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <array>

#include <folly/Range.h>
#include <folly/dynamic.h>

namespace carbon {
namespace test {

struct CarbonThriftTestRouterStatsConfig {
  static constexpr size_t kNumRequestGroups = 3;
  static constexpr std::array<folly::StringPiece, 1 * kNumRequestGroups>
      sumStatNames{{folly::StringPiece("cmd_customRequest_count"),
                    folly::StringPiece("cmd_test_count"),
                    folly::StringPiece("cmd_thrift_test_count")}};
  static constexpr std::array<folly::StringPiece, 3 * kNumRequestGroups>
      rateStatNames{{folly::StringPiece("cmd_customRequest"),
                     folly::StringPiece("cmd_test"),
                     folly::StringPiece("cmd_thrift_test"),
                     folly::StringPiece("cmd_customRequest_out"),
                     folly::StringPiece("cmd_test_out"),
                     folly::StringPiece("cmd_thrift_test_out"),
                     folly::StringPiece("cmd_customRequest_out_all"),
                     folly::StringPiece("cmd_test_out_all"),
                     folly::StringPiece("cmd_thrift_test_out_all")}};

  template <class Request>
  static constexpr size_t getStatGroup();
};

template <>
inline constexpr size_t
CarbonThriftTestRouterStatsConfig::getStatGroup<CustomRequest>() {
  return 0; // stat group 'customRequest'
}

template <>
inline constexpr size_t
CarbonThriftTestRouterStatsConfig::getStatGroup<DummyThriftRequest>() {
  return 2; // stat group 'thrift_test'
}

template <>
inline constexpr size_t
CarbonThriftTestRouterStatsConfig::getStatGroup<ThriftTestRequest>() {
  return 1; // stat group 'test'
}
} // namespace test
} // namespace carbon
