/*
 *  Copyright (c) 2017-present, Facebook, Inc.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <memory>
#include <string>
#include <unordered_map>
#include <vector>

#include <mcrouter/lib/CacheClientStats.h>
#include <mcrouter/lib/carbon/connection/ExternalCarbonConnectionImpl.h>
#include <mcrouter/lib/carbon/connection/InternalCarbonConnectionImpl.h>
#include <mcrouter/lib/carbon/connection/PooledCarbonConnectionImpl.h>

#include "mcrouter/lib/carbon/test/gen/CompactTestMessages.h"
#include "mcrouter/lib/carbon/test/gen/CompactTestRouterInfo.h"

namespace carbon {
namespace test {

class CompactTestConnection {
 public:
  using RouterInfo = CompactTestRouterInfo;

  virtual ~CompactTestConnection() = default;

  virtual void sendRequestOne(
      const TestCompactRequest&,
      carbon::RequestCb<TestCompactRequest>) = 0;

  virtual void sendRequestMulti(
      std::vector<std::reference_wrapper<const TestCompactRequest>>&&,
      carbon::RequestCb<TestCompactRequest>) = 0;

  virtual facebook::memcache::CacheClientCounters getStatCounters() const
      noexcept = 0;
  virtual std::unordered_map<std::string, std::string> getConfigOptions() = 0;
  virtual bool healthCheck() = 0;
  virtual std::unique_ptr<CompactTestConnection> recreate() = 0;
};

template <class Impl>
class CompactTestConnectionImpl : public CompactTestConnection {
 public:
  template <class... Args>
  explicit CompactTestConnectionImpl(Args&&... args)
      : impl_(std::forward<Args>(args)...) {}

  ~CompactTestConnectionImpl() = default;

  facebook::memcache::CacheClientCounters getStatCounters() const noexcept {
    return impl_.getStatCounters();
  }

  std::unordered_map<std::string, std::string> getConfigOptions() {
    return impl_.getConfigOptions();
  }

  bool healthCheck() {
    return impl_.healthCheck();
  }

  std::unique_ptr<CompactTestConnection> recreate() {
    return impl_.template recreate<CompactTestConnectionImpl<Impl>>();
  }

  void sendRequestOne(
      const TestCompactRequest& req,
      carbon::RequestCb<TestCompactRequest> cb) {
    return impl_.sendRequestOne(req, std::move(cb));
  }

  void sendRequestMulti(
      std::vector<std::reference_wrapper<const TestCompactRequest>>&& reqs,
      carbon::RequestCb<TestCompactRequest> cb) {
    return impl_.sendRequestMulti(std::move(reqs), std::move(cb));
  }

 private:
  Impl impl_;
};

using CompactTestPooledConnection = CompactTestConnectionImpl<
    carbon::PooledCarbonConnectionImpl<CompactTestConnection>>;
using CompactTestInternalConnection = CompactTestConnectionImpl<
    carbon::InternalCarbonConnectionImpl<CompactTestConnection>>;
using CompactTestExternalConnection =
    CompactTestConnectionImpl<carbon::ExternalCarbonConnectionImpl>;
} // namespace test
} // namespace carbon
