/*
 *  Copyright (c) 2017-present, Facebook, Inc.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <string>
#include <utility>

#include <mcrouter/lib/RouteHandleTraverser.h>

#include "mcrouter/lib/carbon/test/gen/CompactTestMessages.h"

namespace carbon {
namespace test {

template <class Route>
class CompactTestRouteHandle;

class CompactTestRouteHandleIf {
 public:
  template <class Route>
  using Impl = CompactTestRouteHandle<Route>;

  /**
   * Returns a string identifying this route handle instance
   */
  virtual std::string routeName() const = 0;

  virtual ~CompactTestRouteHandleIf() = default;

  virtual TestCompactReply route(const TestCompactRequest&) = 0;

  virtual void traverse(
      const TestCompactRequest&,
      const facebook::memcache::RouteHandleTraverser<CompactTestRouteHandleIf>&)
      const = 0;
};

template <class Route>
class CompactTestRouteHandle : public CompactTestRouteHandleIf {
 public:
  template <class... Args>
  explicit CompactTestRouteHandle(Args&&... args)
      : route_(std::forward<Args>(args)...) {}
  std::string routeName() const override final {
    return route_.routeName();
  }

  TestCompactReply route(const TestCompactRequest& request) override final {
    return route_.route(request);
  }

  void traverse(
      const TestCompactRequest& request,
      const facebook::memcache::RouteHandleTraverser<CompactTestRouteHandleIf>&
          traverser) const override final {
    route_.traverse(request, traverser);
  }

 private:
  Route route_;
};
} // namespace test
} // namespace carbon
