/*
 *  Copyright (c) 2017-present, Facebook, Inc.
 *
 *  This source code is licensed under the MIT license found in the LICENSE
 *  file in the root directory of this source tree.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 *  @generated
 */
#pragma once

#include <functional>
#include <unordered_map>

#include <folly/Range.h>

#include <mcrouter/lib/carbon/Stats.h>

#include "mcrouter/lib/carbon/test/gen/CompactTestRouteHandleIf.h"
#include "mcrouter/lib/carbon/test/gen/CompactTestRouterStats.h"

// Forward declarations
namespace folly {
struct dynamic;
} // namespace folly

namespace facebook {
namespace memcache {
template <class RouteHandleIf>
class RouteHandleFactory;
namespace mcrouter {
template <class RouterInfo>
class ExtraRouteHandleProviderIf;
} // namespace mcrouter
} // namespace memcache
} // namespace facebook

namespace carbon {
namespace test {

namespace detail {

using CompactTestRoutableRequests = carbon::List<TestCompactRequest>;
} // namespace detail

struct CompactTestRouterInfo {
  using RouteHandleIf = CompactTestRouteHandleIf;
  using RouteHandlePtr = std::shared_ptr<RouteHandleIf>;

  static constexpr const char* name = "CompactTest";

  template <class Route>
  using RouteHandle = CompactTestRouteHandle<Route>;
  using RoutableRequests = detail::CompactTestRoutableRequests;

  using RouterStats = carbon::Stats<CompactTestRouterStatsConfig>;

  using RouteHandleFactoryMap = std::unordered_map<
      folly::StringPiece,
      std::function<RouteHandlePtr(
          facebook::memcache::RouteHandleFactory<RouteHandleIf>&,
          const folly::dynamic&)>,
      folly::Hash>;

  static RouteHandleFactoryMap buildRouteMap();

  static std::unique_ptr<facebook::memcache::mcrouter::
                             ExtraRouteHandleProviderIf<CompactTestRouterInfo>>
  buildExtraProvider();
};
} // namespace test
} // namespace carbon
